/*
 * buttons_interface.xc
 *
 *  Created on: 13/apr/2018
 *      Author: fabrizio
 */

#include <xs1.h>
#include <stdint.h>
#include <print.h>

[[combinable]]
void buttons_man(in port p_button)
{
#if 0 //DEBUG
    timer t;
    uint32_t time;
    const uint32_t period = 100000000; // 1sec
    uint32_t current_val = 0xFF;

    // get the initial timer value
    t :> time;
    while(1) {
      select {
      case t when timerafter(time) :> void:
        // perform periodic task
        time += period;
        p_button :> current_val;    // DOES NOT WORK
        printuintln(current_val);
        break;
      }
    }
#elif 0
    // *** DOES NOT WORK ***
    int current_val = 0;
    int is_stable = 1;
    timer tmr;
    const unsigned debounce_delay_ms = 50;
    unsigned debounce_timeout;
    while (1) {
        select {
        // If the button is "stable", react when the I/O pin changes value
        case is_stable => p_button when pinsneq(current_val) :> current_val:
            printuintln(current_val);
            /* if (current_val == 1) {
                printf("Button up\n");
            } else {
                printf("Button down\n");
            }*/
            is_stable = 0;
            int current_time;
            tmr :> current_time;
            // Calculate time to event after debounce period
            // note that XS1_TIMER_HZ is defined in timer.h
            debounce_timeout = current_time + (debounce_delay_ms * XS1_TIMER_HZ);
            break;

        // If the button is not stable (i.e. bouncing around) then select
        // when we the timer reaches the timeout to renter a stable period
        case !is_stable => tmr when timerafter(debounce_timeout) :> void:
            is_stable = 1;
            break;
        }
    }
#else
    // *** DOES NOT WORK ***
    /*
     * return error:
xrun: Program received signal ET_ILLEGAL_RESOURCE, Resource exception.
      [Switching to tile[0] core[3] (dual issue)]
      buttons_man (p_button=1) at C:/Users/fabrizio/xTIME/workspace_vocalfusion/lib_frs/src/buttons_interface.xc:84

      84            select {
     */
    // The last read value off the port.
    int current_val = 0;
    while (1) {
        select {
        // event when the button changes value
        case p_button when pinsneq(current_val) :> int new_val:
            printuintln(new_val);
/*            if (new_val == 1) {
                printf("Button up\n");
            } else {
                printf("Button down\n");
            }*/
            current_val = new_val;
            break;
        }
    }
#endif
}
